rng('default');
close all;

% Totalerrorvec = zeros(10,1);
% errortot=zeros(5*(testlength+1)/2,n_o);
%% generate trainingset

run init_gravityseparator.m; 
tstart = tic; %start timer for simulater
sim('gravityseparator',time_length)   % Simulate the Simulink model 'gravityseparator.slx' (has to be in the same folder as this file)
t_simulation_time = toc(tstart);

U_training=[qGout.signals.values,qWout.signals.values,qOout.signals.values,p.signals.values,hL.signals.values,hW.signals.values,pdes.signals.values,hWdes.signals.values,hLdes.signals.values];
Y_target= [qLin.signals.values,qGin.signals.values,gamma.signals.values,hW1.signals.values,hL1.signals.values,p1.signals.values];
[m,n]=size(U_training); 

%% different hyperparameters values
td_dvalues=8:4:44; % dealy of input
ressize=[50,100,250,500,1000]; % reservoir weights
resweights=[0.25,0.17,0.108,0.075,0.055]; % reservoir distribution
alpha_values = 0.1:0.1:1;
lambda_values = 0.1:0.1:1;
%for lap=1:10 % used inrange searsh
%% Build ESN
timedelay = td_dvalues(3); % How far back in time for input from a previous timestep
n_o = 3;        %output size, 6 for including states
n_r =ressize(4); % reservoir size
n_i = 6*2;      % input size multiplied by two for including dealayed input
range = resweights(4); %range of uniformly distrubution of weights 
fb = 0; % 1 for including feedback, 0 for exclude
zero_elements = 0; % percentage og zero elements in W_in
[W_r,W_i,W_o,W_f] = Initilize_weights(n_r,n_i,n_o,range,fb,zero_elements);
alpha = alpha_values(6); % leaking rate
lambda = lambda_values(3);% regularization coefficient for analythic solution
reg_choise = 0; % choose regularization method, 0 for analytic Ridge,  1 for LASSO and 10^-5 for Ridge
lin_relation = 1; % 1 = connectin input linearly to output, 0 no connection 

%% analasys of Echo state property
spectral_radius = max(abs(eig(W_r))); %good value 1
max_singular_value = max(svds(W_r));
ESP_test = 1-alpha*(1-max_singular_value); % Sufficient condidtion for < 1
W_tilde = alpha*W_r+(1-alpha)*eye(n_r); 
effective_spectral_radius = max(abs(eig(W_tilde))); % necessary condotion  for < 1

%% harveset states X
x = zeros(n_r,1); %initial contidion for states
y = Y_target(1,1:n_o); %initial contidion for estimate
X=zeros(n_r+n_i,m-timedelay); 
for i = (1+timedelay):m
    input = [U_training(i,1:n_i/2),U_training(i-timedelay,1:n_i/2)];
    x = update_x_ESN(x,y,input,W_r,W_i,W_f,alpha);
    if lin_relation == 1 % connect input directly to output
        x_o=[x;U_training(i,1:n_i/2)';U_training(i-timedelay,1:n_i/2)']; 
    elseif lin_relation == 0  % Don't connect input directly to output
        x_o=[x;zeros(n_i,1)];
    end
    y = (update_y(x_o,W_o))';
    X(:,i-timedelay)=x_o;
end

%%  Train ESN
tstart = tic; %start time of training
output_constant = zeros(n_o,1); % no constant for ridge analythic 
if reg_choise == 0 %  RIDGE analytic solution
    W_o=((Y_target(1:(m-timedelay),1:n_o)' * X')/( X * X' + lambda * eye(n_r+n_i)))'; 
else % training using built in lasso function
    for i = 1:n_o
        [BlassoAll,FitInfo] = lasso(X',Y_target(1:(m-timedelay),i)', 'Alpha', reg_choise, 'CV', 10);
        Blasso=[FitInfo.Intercept(FitInfo.Index1SE); BlassoAll(:,FitInfo.Index1SE)];
        output_constant(i) = Blasso(1); % constant part
        W_o(:,i)=Blasso(2:n_r+n_i+1); % 
    end
end
t_training_time = toc(tstart); % time to train ESN

%% test on training data 
x = zeros(n_r,1); %initial contidion for states 
estimate = zeros(m,n_o);
y = Y_target(1,1:n_o);
estimate(1,:)=y;
for i = 1+timedelay:m % start on two 
    x = update_x_ESN(x,y,[U_training(i,1:n_i/2),U_training(i-timedelay,1:n_i/2)],W_r,W_i,W_f,alpha);
    if lin_relation == 1 % connect input directly to output
        x_o=[x;U_training(i,1:n_i/2)';U_training(i-timedelay,1:n_i/2)']; 
    elseif lin_relation == 0  % Don't connect input directly to output
        x_o=[x;zeros(n_i,1)];
    end
    y = update_y(x_o,W_o)'+output_constant';
    estimate(i,:)=y;
end

%% Plot Training
%run plot_training_set.m; 


%% generate test set
run test_set_signals.m; 
%% SIMULATE

tic
sim('gravityseparator',testtime_length)   % Simulate the Simulink model 'gravityseparator.slx' (has to be in the same folder as this file)
toc


U_test=[qGout.signals.values,qWout.signals.values,qOout.signals.values,p.signals.values,hL.signals.values,hW.signals.values,pdes.signals.values,hWdes.signals.values,hLdes.signals.values];
Y_test= [qLin.signals.values,qGin.signals.values,gamma.signals.values,hW1.signals.values,hL1.signals.values,p1.signals.values];
[testlength,n]=size(U_test);

alpha = alpha_values(6); % alpha is also a value in simulink
%% esetimate 
x = zeros(n_r,1); %initial contidion for states 
test_estimate = zeros(testlength,n_o);
y = Y_test(1,1:n_o);
test_estimate(1,:)=y;
for i = 1+timedelay:testlength % start on two 
    x = update_x_ESN(x,y,[U_test(i,1:n_i/2),U_test(i-timedelay,1:n_i/2)],W_r,W_i,W_f,alpha);
    if lin_relation == 1 % connect input directly to output
        x_o=[x;U_test(i,1:n_i/2)';U_test(i-timedelay,1:n_i/2)']; 
    elseif lin_relation == 0  % Don't connect input directly to output
        x_o=[x;zeros(n_i,1)];
    end
    y = update_y(x_o,W_o)'+output_constant';
    test_estimate(i,:)=y;
end
%% plots

figure(6)% Plot test data
subplot(3,2,1) 
plot(hW.time,hW.signals.values,'b')
hold on
plot(hWdes.time,hWdes.signals.values,'r')
ylabel('[m]')
title('Water level h_W')
%legend('Real','Desired')
axis([1+timedelay hW.time(end) .8 1.8])

subplot(3,2,2) % Plot the water outflow
plot(qWout.time,qWout.signals.values)
ylabel('[m^3 s^{-1}]')
title('Water outflow q_{W,out}')

subplot(3,2,3) % Plot the actual and desired liquid levels
plot(hL.time,hL.signals.values,'b')
hold on
plot(hLdes.time,hLdes.signals.values,'r')
ylabel('[m]')
title('Liquid level h_L')
%legend('Real','Desired')
axis([0 hL.time(end) 2.2 2.8])

subplot(3,2,4) % Plot the oil outflow
plot(qOout.time,qOout.signals.values)
ylabel('[m^3 s^{-1}]')
title('Oil outflow q_{O,out}')

subplot(3,2,5) % Plot the pressure
plot(p.time,p.signals.values,'b')
hold on
plot(pdes.time,pdes.signals.values,'r')
xlabel('Time [s]')
ylabel('[bar]')
title('Gas pressure')
%legend('Real','Desired')
axis([0 p.time(end) 65 72])

subplot(3,2,6) % Plot the gas outflow
plot(qGout.time,qGout.signals.values)
xlabel('Time [s]')
ylabel('[m^3 s^{-1}]')
title('Gas outflow q_{G,out}')

figure(7)% Plot the actual and estimated 
subplot(3,1,1) 
plot(qLin.time,qLin.signals.values,'r','LineWidth',1.5)
hold on
plot(qLin.time(1+timedelay:testlength),test_estimate(1+timedelay:testlength,1))
ylabel('[m^3/s]')
title('Liquid inflow qL_in')
%legend('Real','est. \tau_d = 0','est. \tau_d = 10','est. \tau_d = 25','est. \tau_d = 50','est. \tau_d = 100','est. \tau_d = 200')
%legend('Real','estimated')

subplot(3,1,2) 
plot(qGin.time,qGin.signals.values,'r','LineWidth',1.5)
hold on
plot(qGin.time(1+timedelay:testlength),test_estimate(1+timedelay:testlength,2))
ylabel('[m^3/s]')
title('Gas inflow qG_in')
%legend('Real','est. \tau_d = 0','est. \tau_d = 10','est. \tau_d = 25','est. \tau_d = 50','est. \tau_d = 100','est. \tau_d = 200')
%legend('Real','estimated')

subplot(3,1,3) 
plot(gamma.time,gamma.signals.values,'r','LineWidth',1.5)
hold on
plot(gamma.time((1+timedelay:testlength)),test_estimate((1+timedelay:testlength),3))
ylabel('[m^3/s]')
xlabel('Time [s]')
title('split ratio \gamma')
%legend('Real','est. \tau_d = 0','est. \tau_d = 10','est. \tau_d = 25','est. \tau_d = 50','est. \tau_d = 100','est. \tau_d = 100')
%legend('Real','estimated')

% figure(8)% Plot test state estimation
% subplot(3,1,1) 
% 
% plot(hW.time,hW.signals.values,'b')
% hold on
% plot(hW.time((1+timedelay:testlength)),test_estimate((1+timedelay:testlength),4),'r')
% plot(hW1.time,hW1.signals.values,'g')
% ylabel('[m]')
% title('Water level')
% %axis([0 hL.time(end) 2.2 2.8])

% subplot(3,1,2) 
% plot(hL.time,hL.signals.values,'b')
% hold on
% plot(hL.time((1+timedelay:testlength)),test_estimate((1+timedelay:testlength),5),'r')
% plot(hL1.time,hL1.signals.values,'g')
% ylabel('[m]')
% title('Liquid level')
% %axis([1+timedelay hW.time(end) .8 1.8])
% 
% subplot(3,1,3) % Plot the pressure
% plot(p.time,p.signals.values,'b')
% hold on
% plot(p.time((1+timedelay:testlength)),test_estimate((1+timedelay:testlength),6),'r')
% plot(p.time,p1.signals.values,'g')
% xlabel('Time [s]')
% ylabel('[bar]')
% title('Gas pressure')
%axis([0 p.time(end) 65 72])


% error=abs(test_estimate-Y_test(:,1:n_o));
% errortot(1+(lap-1)*(testlength+1)/2:(testlength+1)/2*lap,1:n_o)=error((testlength+1)/2:testlength,1:n_o);
% end
% error_rescaled=[rescale(errortot(:,1)),rescale(errortot(:,2)),rescale(errortot(:,3))];
% for lap = 1:10
%     errersum_rescaled= zeros((testlength+1)/2,1);
%     for i = 1:(testlength+1)/2
%         for j=3:3
%         errersum_rescaled(i) = errersum_rescaled(i)+error_rescaled(i+(lap-1)*(testlength+1)/2,j); 
%         end
%     end
%     Totalerror = sum(errersum_rescaled(1:(testlength+1)/2));
%     Totalerrorvec(lap)= Totalerror;
% end
% figure;
% plot(td_dvalues/2,Totalerrorvec,'o')
% title('Error plot')
% ylabel('sum of rezsized errors')
% xlabel('\tau_d')
