%% Plot 1
figure(1)
subplot(3,2,1) % Plot the actual and desired water levels
plot(hW.time(1:m-timedelay),hW.signals.values(1:m-timedelay),'b')
hold on
plot(hW.time(1:m-timedelay),estimate(1+timedelay:m,1),'r')
ylabel('[m]')
title('Water level h_W')
legend('Real','estimated')
axis([1+timedelay hW.time(end) .8 1.8])

subplot(3,2,2) % Plot the water outflow
plot(qWout.time,qWout.signals.values)
ylabel('[m^3 s^{-1}]')
title('Water outflow q_{W,out}')

subplot(3,2,3) % Plot the actual and desired liquid levels
plot(hL.time(1:m-timedelay),hL.signals.values(1:m-timedelay),'b')
hold on
plot(hL.time(1:m-timedelay),estimate(1+timedelay:m,2),'r')
ylabel('[m]')
title('Liquid level h_L')
legend('Real','estimated')
%axis([0 hL.time(end) 2.2 2.8])

subplot(3,2,4) % Plot the oil outflow
plot(qOout.time,qOout.signals.values)
ylabel('[m^3 s^{-1}]')
title('Oil outflow q_{O,out}')

subplot(3,2,5) % Plot the pressure
plot(p.time(1:m-timedelay),p.signals.values(1:m-timedelay),'b')
hold on
plot(p.time(1:m-timedelay),estimate(1+timedelay:m,3),'r')
xlabel('Time [s]')
ylabel('[bar]')
title('Gas pressure')
legend('Real','estimated')
%axis([0 p.time(end) 65 72])

subplot(3,2,6) % Plot the gas outflow
plot(qGout.time,qGout.signals.values)
xlabel('Time [s]')
ylabel('[m^3 s^{-1}]')
title('Gas outflow q_{Gout}')

figure(2)
subplot(3,1,1) % Plot the actual and desired water levels
plot(qLin.time(1:m-timedelay),qLin.signals.values(1:m-timedelay),'b')
hold on
plot(qLin.time(1:m-timedelay),estimate(1+timedelay:m,4),'r')
ylabel('[m^3/s]')
title('Liquid inflow q_{Lin}')
legend('Real','estimated')

subplot(3,1,2) % Plot the actual and desired water levels
plot(qGin.time(1:m-timedelay),qGin.signals.values(1:m-timedelay),'b')
hold on
plot(qGin.time(1:m-timedelay),estimate(1+timedelay:m,5),'r')
ylabel('[m^3/s]')
title('Gas inflow q_{Gin}')
legend('Real','estimated')

subplot(3,1,3) % Plot the actual and desired water levels
plot(gamma.time(1:m-timedelay),gamma.signals.values(1:m-timedelay),'b')
hold on
plot(gamma.time(1:m-timedelay),estimate(1+timedelay:m,6),'r')
ylabel('[m^3/s]')
title('split ratio \gamma')
legend('Real','estimated')
xlabel('Time [s]')
figure(3);
subplot(3,1,1) % Plot the actual and desired water levels
plot(hW.time,hW.signals.values,'b')
hold on
plot(hWdes.time,hWdes.signals.values,'r')
ylabel('Height [m]')
title('Water level h_W')
legend('real','Desired')
%axis([0 hW.time(end) .8 1.8])

subplot(3,1,2) % Plot the actual and desired liquid levels
plot(hL.time,hL.signals.values,'b')
hold on
plot(hLdes.time,hLdes.signals.values,'r')
ylabel('Height [m]')
title('Liquid level h_L')
legend('real','Desired')
%axis([0 hL.time(end) 2.2 2.8])

subplot(3,1,3) % Plot the pressure
plot(p.time,p.signals.values,'b')
hold on
plot(pdes.time,pdes.signals.values,'r')
xlabel('Time [s]')
ylabel('Pressure [bar]')
title('Pressure')
legend('real','Desired')
%axis([0 p.time(end) 65 72])

figure(4);
plot(gamma.time,gamma.signals.values,'b')
hold on
plot(water_cut.time,water_cut.signals.values,'r')
title('alpha vs \gamma')
legend('\gamma','\alpha')
xlabel('Time [s]')
figure(5);
subplot(3,1,1) % Plot the water outflow
plot(qWout.time,qWout.signals.values)
ylabel('Flow [m^3 s^{-1}]')
title('Water outflow q_{Wout}')

subplot(3,1,2) % Plot the oil outflow
plot(qOout.time,qOout.signals.values)
ylabel('Flow [m^3 s^{-1}]')
title('Oil outflow q_{Oout}')

subplot(3,1,3) % Plot the gas outflow
plot(qGout.time,qGout.signals.values)
xlabel('Time [s]')
ylabel('Flow [m^3 s^{-1}]')
title('Gas outflow q_{Gout}')